/*
 * Copyright (c) 2004 Roman Bogorodskiy (bogorodskiy@inbox.ru)
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the 
 * Software is furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software. 
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL 
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 * DEALINGS IN THE SOFTWARE.
 *
 * $Header: /cvsroot/phptags/phptags/src/str.c,v 1.3 2004/11/05 15:13:43 mirrorbox Exp $
 * 
 */

/* expand_filename(): ~/test -> /home/user/test */

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <sysexits.h>

char *expand_filename(char *str)
{
	
	if (str[0] != '~') 
		return str;

	str++; 

	if ((int)getenv("HOME") != -1) {
		char *home;
		home = (char *)getenv("HOME");
		str = strcat(home, str);
	} else {
		(void)fprintf(stderr, "Error: environment variable HOME is not set.\n");
		exit(EX_CONFIG);
	}

	return str;
}

#ifndef HAVE_STRNSTR

/*
 * Copyright (c) 2001 Mike Barcroft <mike@FreeBSD.org>
 * Copyright (c) 1990, 1993
 * The Regents of the University of California.  All rights reserved.
 *  
 *  This code is derived from software contributed to Berkeley by
 *  Chris Torek.
 */    	

char *
strnstr(const char *s, const char *find, size_t slen)
{
        char c, sc;
        size_t len;

        if ((c = *find++) != '\0') {
                len = strlen(find);
                do {
                        do {
                                if ((sc = *s++) == '\0' || slen-- < 1)
                                        return (NULL);
                        } while (sc != c);
                        if (len > slen)
                                return (NULL);
                } while (strncmp(s, find, len) != 0);
                s--;
        }
 
 	return ((char *)s);
}
#endif
